
_Timer0_COMP_Interrupt:

;os.c,38 :: 		void Timer0_COMP_Interrupt() iv IVT_ADDR_TIMER0_COMP ics ICS_OFF
;os.c,47 :: 		asm { push r16
	PUSH       R16
;os.c,48 :: 		in r16,SREG
	IN         R16, SREG+0
;os.c,49 :: 		push r16        };
	PUSH       R16
;os.c,51 :: 		asm {    lds r16,_tick
	LDS        R16, _tick+0
;os.c,52 :: 		inc r16
	INC        R16
;os.c,53 :: 		brcc 1f
	BRCC       1f
;os.c,54 :: 		inc r16
	INC        R16
;os.c,55 :: 		1f:
1f:
;os.c,56 :: 		sts _tick,r16};
	STS        _tick+0, R16
;os.c,59 :: 		asm {lds r16,_b_status          ; load background task flag
	LDS        R16, _b_status+0
;os.c,60 :: 		subi r16,02
	SUBI       R16, 2
;os.c,61 :: 		BREQ 2f
	BREQ       2f
;os.c,62 :: 		pop r16
	POP        R16
;os.c,63 :: 		out SREG,r16
	OUT        SREG+0, R16
;os.c,64 :: 		pop r16
	POP        R16
;os.c,65 :: 		reti
	RETI
;os.c,66 :: 		2f:
2f:
;os.c,67 :: 		ldi r16,0x04
	LDI        R16, 4
;os.c,68 :: 		sts _b_status,r16
	STS        _b_status+0, R16
;os.c,69 :: 		push R0
	PUSH       R0
;os.c,70 :: 		push R1
	PUSH       R1
;os.c,71 :: 		push R2
	PUSH       R2
;os.c,72 :: 		push R3
	PUSH       R3
;os.c,73 :: 		push R4
	PUSH       R4
;os.c,74 :: 		push R5
	PUSH       R5
;os.c,75 :: 		push R6
	PUSH       R6
;os.c,76 :: 		push R7
	PUSH       R7
;os.c,77 :: 		push R8
	PUSH       R8
;os.c,78 :: 		push R9
	PUSH       R9
;os.c,79 :: 		push R10
	PUSH       R10
;os.c,80 :: 		push R11
	PUSH       R11
;os.c,81 :: 		push R12
	PUSH       R12
;os.c,82 :: 		push R13
	PUSH       R13
;os.c,83 :: 		push R14
	PUSH       R14
;os.c,84 :: 		push R15
	PUSH       R15
;os.c,85 :: 		push R17
	PUSH       R17
;os.c,86 :: 		push R18
	PUSH       R18
;os.c,87 :: 		push R19
	PUSH       R19
;os.c,88 :: 		push R20
	PUSH       R20
;os.c,89 :: 		push R21
	PUSH       R21
;os.c,90 :: 		push R22
	PUSH       R22
;os.c,91 :: 		push R23
	PUSH       R23
;os.c,92 :: 		push R24
	PUSH       R24
;os.c,93 :: 		push R25
	PUSH       R25
;os.c,94 :: 		push R26
	PUSH       R26
;os.c,95 :: 		push R27
	PUSH       R27
;os.c,96 :: 		push R28
	PUSH       R28
;os.c,97 :: 		push R29
	PUSH       R29
;os.c,98 :: 		push R30
	PUSH       R30
;os.c,99 :: 		push R31
	PUSH       R31
;os.c,100 :: 		lds r16,_kl
	LDS        R16, _kl+0
;os.c,101 :: 		push r16
	PUSH       R16
;os.c,102 :: 		lds r16,_kh
	LDS        R16, _kh+0
;os.c,103 :: 		push r16
	PUSH       R16
;os.c,104 :: 		ldi r16,0x00
	LDI        R16, 0
;os.c,105 :: 		out SREG,r16
	OUT        SREG+0, R16
;os.c,106 :: 		reti
	RETI
;os.c,108 :: 		}
L_end_Timer0_COMP_Interrupt:
	RETI
; end of _Timer0_COMP_Interrupt

_os_startup:

;os.c,110 :: 		void os_startup (void)
;os.c,113 :: 		OCR0 = CCOVF;
	LDI        R27, 78
	OUT        OCR0+0, R27
;os.c,114 :: 		TCCR0 = prescaler | 0x08;
	LDI        R27, 14
	OUT        TCCR0+0, R27
;os.c,115 :: 		TCNT0 = 0x00;
	LDI        R27, 0
	OUT        TCNT0+0, R27
;os.c,116 :: 		TIMSK = 0x02;
	LDI        R27, 2
	OUT        TIMSK+0, R27
;os.c,118 :: 		MCUCR = 0x20;
	LDI        R27, 32
	OUT        MCUCR+0, R27
;os.c,119 :: 		tick = 0;
	LDI        R27, 0
	STS        _tick+0, R27
;os.c,120 :: 		sei;
	IN         R27, SREG_I_bit+0
	SBR        R27, 128
	OUT        SREG_I_bit+0, R27
;os.c,121 :: 		}
L_end_os_startup:
	RET
; end of _os_startup

_task_setup:

;os.c,130 :: 		void task_setup(void)
;os.c,132 :: 		os_task[0].taskstatus = t_idel;
	LDI        R27, 0
	STS        _os_task+0, R27
;os.c,133 :: 		os_task[0].tickcount = 2;
	LDI        R27, 2
	STS        _os_task+1, R27
;os.c,134 :: 		os_task[0].decrement = os_task[0].tickcount;
	LDI        R27, 2
	STS        _os_task+2, R27
;os.c,136 :: 		os_task[1].taskstatus = t_idel;
	LDI        R27, 0
	STS        _os_task+3, R27
;os.c,137 :: 		os_task[1].tickcount = 4;
	LDI        R27, 4
	STS        _os_task+4, R27
;os.c,138 :: 		os_task[1].decrement = os_task[1].tickcount;
	LDI        R27, 4
	STS        _os_task+5, R27
;os.c,140 :: 		os_task[2].taskstatus = t_idel;
	LDI        R27, 0
	STS        _os_task+6, R27
;os.c,141 :: 		os_task[2].tickcount = 40;
	LDI        R27, 40
	STS        _os_task+7, R27
;os.c,142 :: 		os_task[2].decrement = os_task[2].tickcount;
	LDI        R27, 40
	STS        _os_task+8, R27
;os.c,144 :: 		b_status = t_idel;
	LDI        R27, 0
	STS        _b_status+0, R27
;os.c,146 :: 		kernel_address = (unsigned int ) &kernel;
	LDI        R18, #lo_addr(_kernel+0)
	LDI        R19, hi_addr(_kernel+0)
	STS        _kernel_address+0, R18
	STS        _kernel_address+1, R19
;os.c,147 :: 		kh = (char) (kernel_address >> 8);
	MOV        R16, R19
	LDI        R17, 0
	STS        _kh+0, R16
;os.c,148 :: 		kl = (char) (kernel_address );
	STS        _kl+0, R18
;os.c,150 :: 		}
L_end_task_setup:
	RET
; end of _task_setup

_kernel:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;os.c,153 :: 		void kernel ( void )
;os.c,157 :: 		while (1)
L_kernel0:
;os.c,159 :: 		if (tick != 0)
	LDS        R16, _tick+0
	CPI        R16, 0
	BRNE       L__kernel27
	JMP        L_kernel2
L__kernel27:
;os.c,162 :: 		cli;
	IN         R27, SREG_I_bit+0
	CBR        R27, 128
	OUT        SREG_I_bit+0, R27
;os.c,163 :: 		TIMSK = TIMSK & 0xFD;
	IN         R16, TIMSK+0
	ANDI       R16, 253
	OUT        TIMSK+0, R16
;os.c,164 :: 		sei;
	IN         R27, SREG_I_bit+0
	SBR        R27, 128
	OUT        SREG_I_bit+0, R27
;os.c,165 :: 		for (i= 0; i <(tasks_no) ; i++)
	LDI        R27, 0
	STD        Y+0, R27
L_kernel3:
	LDD        R16, Y+0
	CPI        R16, 3
	BRLO       L__kernel28
	JMP        L_kernel4
L__kernel28:
;os.c,169 :: 		if (os_task[i].taskstatus != t_suspend)
	LDI        R16, 3
	LDI        R17, 0
	LDD        R20, Y+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_os_task+0)
	LDI        R19, hi_addr(_os_task+0)
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LD         R16, Z
	CPI        R16, 8
	BRNE       L__kernel29
	JMP        L_kernel6
L__kernel29:
;os.c,172 :: 		os_task[i].decrement = os_task[i].decrement - tick;
	LDI        R16, 3
	LDI        R17, 0
	LDD        R20, Y+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_os_task+0)
	LDI        R19, hi_addr(_os_task+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R18, R16
	SUBI       R18, 254
	SBCI       R19, 255
	MOVW       R30, R18
	LD         R16, Z
	LDS        R0, _tick+0
	SUB        R16, R0
	MOVW       R30, R18
	ST         Z, R16
;os.c,174 :: 		if (os_task[i].decrement > os_task[i].tickcount)
	LDI        R16, 3
	LDI        R17, 0
	LDD        R20, Y+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_os_task+0)
	LDI        R19, hi_addr(_os_task+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	ADIW       R30, 2
	LD         R18, Z
	MOVW       R30, R16
	ADIW       R30, 1
	LD         R16, Z
	CP         R16, R18
	BRLO       L__kernel30
	JMP        L_kernel7
L__kernel30:
;os.c,176 :: 		os_task[i].decrement = 255 - os_task[i].decrement ;
	LDI        R16, 3
	LDI        R17, 0
	LDD        R20, Y+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_os_task+0)
	LDI        R19, hi_addr(_os_task+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R18, R16
	SUBI       R18, 254
	SBCI       R19, 255
	MOVW       R30, R18
	LD         R16, Z
	MOV        R0, R16
	LDI        R16, 255
	SUB        R16, R0
	MOVW       R30, R18
	ST         Z, R16
;os.c,177 :: 		os_task[i].decrement = os_task[i].tickcount - os_task[i].decrement -1;
	LDI        R16, 3
	LDI        R17, 0
	LDD        R20, Y+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_os_task+0)
	LDI        R19, hi_addr(_os_task+0)
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R18, R16
	SUBI       R18, 254
	SBCI       R19, 255
	MOVW       R30, R16
	ADIW       R30, 1
	LD         R17, Z
	MOVW       R30, R18
	LD         R16, Z
	MOV        R0, R16
	MOV        R16, R17
	SUB        R16, R0
	SUBI       R16, 1
	MOVW       R30, R18
	ST         Z, R16
;os.c,180 :: 		if(os_task[i].taskstatus == t_idel)
	LDI        R16, 3
	LDI        R17, 0
	LDD        R20, Y+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_os_task+0)
	LDI        R19, hi_addr(_os_task+0)
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LD         R16, Z
	CPI        R16, 0
	BREQ       L__kernel31
	JMP        L_kernel8
L__kernel31:
;os.c,184 :: 		os_task[i].taskstatus = t_activate;
	LDI        R16, 3
	LDI        R17, 0
	LDD        R20, Y+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_os_task+0)
	LDI        R19, hi_addr(_os_task+0)
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LDI        R27, 1
	ST         Z, R27
;os.c,186 :: 		}
	JMP        L_kernel9
L_kernel8:
;os.c,190 :: 		}
L_kernel9:
;os.c,191 :: 		}
	JMP        L_kernel10
L_kernel7:
;os.c,195 :: 		}
L_kernel10:
;os.c,196 :: 		}
	JMP        L_kernel11
L_kernel6:
;os.c,199 :: 		}
L_kernel11:
;os.c,165 :: 		for (i= 0; i <(tasks_no) ; i++)
	LDD        R16, Y+0
	SUBI       R16, 255
	STD        Y+0, R16
;os.c,200 :: 		}
	JMP        L_kernel3
L_kernel4:
;os.c,202 :: 		tick=0;
	LDI        R27, 0
	STS        _tick+0, R27
;os.c,204 :: 		cli;
	IN         R27, SREG_I_bit+0
	CBR        R27, 128
	OUT        SREG_I_bit+0, R27
;os.c,205 :: 		TIMSK = TIMSK | 0x02;
	IN         R27, TIMSK+0
	SBR        R27, 2
	OUT        TIMSK+0, R27
;os.c,206 :: 		sei;
	IN         R27, SREG_I_bit+0
	SBR        R27, 128
	OUT        SREG_I_bit+0, R27
;os.c,208 :: 		for (i=0 ;i<(tasks_no);i++)
	LDI        R27, 0
	STD        Y+0, R27
L_kernel12:
	LDD        R16, Y+0
	CPI        R16, 3
	BRLO       L__kernel32
	JMP        L_kernel13
L__kernel32:
;os.c,210 :: 		if (os_task[i].taskstatus == t_activate)
	LDI        R16, 3
	LDI        R17, 0
	LDD        R20, Y+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_os_task+0)
	LDI        R19, hi_addr(_os_task+0)
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LD         R16, Z
	CPI        R16, 1
	BREQ       L__kernel33
	JMP        L_kernel15
L__kernel33:
;os.c,212 :: 		os_task[i].taskstatus = t_run;
	LDI        R16, 3
	LDI        R17, 0
	LDD        R20, Y+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_os_task+0)
	LDI        R19, hi_addr(_os_task+0)
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LDI        R27, 2
	ST         Z, R27
;os.c,213 :: 		f[i]();
	LDD        R16, Y+0
	MOV        R18, R16
	LDI        R19, 0
	LSL        R18
	ROL        R19
	LDI        R16, #lo_addr(_f+0)
	LDI        R17, hi_addr(_f+0)
	MOVW       R30, R18
	ADD        R30, R16
	ADC        R31, R17
	LD         R16, Z+
	LD         R17, Z+
	MOVW       R30, R16
	ICALL
;os.c,214 :: 		cli;
	IN         R27, SREG_I_bit+0
	CBR        R27, 128
	OUT        SREG_I_bit+0, R27
;os.c,215 :: 		os_task[i].taskstatus = t_idel;
	LDI        R16, 3
	LDI        R17, 0
	LDD        R20, Y+0
	LDI        R21, 0
	CALL       _HWMul_16x16+0
	LDI        R18, #lo_addr(_os_task+0)
	LDI        R19, hi_addr(_os_task+0)
	MOVW       R30, R16
	ADD        R30, R18
	ADC        R31, R19
	LDI        R27, 0
	ST         Z, R27
;os.c,216 :: 		sei;
	IN         R27, SREG_I_bit+0
	SBR        R27, 128
	OUT        SREG_I_bit+0, R27
;os.c,217 :: 		}
L_kernel15:
;os.c,208 :: 		for (i=0 ;i<(tasks_no);i++)
	LDD        R16, Y+0
	SUBI       R16, 255
	STD        Y+0, R16
;os.c,219 :: 		}
	JMP        L_kernel12
L_kernel13:
;os.c,223 :: 		if (tick==0)
	LDS        R16, _tick+0
	CPI        R16, 0
	BREQ       L__kernel34
	JMP        L_kernel16
L__kernel34:
;os.c,225 :: 		cli;
	IN         R27, SREG_I_bit+0
	CBR        R27, 128
	OUT        SREG_I_bit+0, R27
;os.c,226 :: 		if (b_status == t_idel)
	LDS        R16, _b_status+0
	CPI        R16, 0
	BREQ       L__kernel35
	JMP        L_kernel17
L__kernel35:
;os.c,228 :: 		b_status = t_run;
	LDI        R27, 2
	STS        _b_status+0, R27
;os.c,229 :: 		f[tasks_no]();
	LDS        R30, _f+6
	LDS        R31, _f+7
	ICALL
;os.c,230 :: 		cli;
	IN         R27, SREG_I_bit+0
	CBR        R27, 128
	OUT        SREG_I_bit+0, R27
;os.c,231 :: 		b_status = t_idel;
	LDI        R27, 0
	STS        _b_status+0, R27
;os.c,232 :: 		sei;
	IN         R27, SREG_I_bit+0
	SBR        R27, 128
	OUT        SREG_I_bit+0, R27
;os.c,233 :: 		}
	JMP        L_kernel18
L_kernel17:
;os.c,234 :: 		else if (b_status == t_interrupt)
	LDS        R16, _b_status+0
	CPI        R16, 4
	BREQ       L__kernel36
	JMP        L_kernel19
L__kernel36:
;os.c,236 :: 		b_status = t_run;
	LDI        R27, 2
	STS        _b_status+0, R27
;os.c,238 :: 		pop r31
	POP        R31
;os.c,239 :: 		pop R30
	POP        R30
;os.c,240 :: 		pop R29
	POP        R29
;os.c,241 :: 		pop R28
	POP        R28
;os.c,242 :: 		pop R27
	POP        R27
;os.c,243 :: 		pop R26
	POP        R26
;os.c,244 :: 		pop R25
	POP        R25
;os.c,245 :: 		pop R24
	POP        R24
;os.c,246 :: 		pop R23
	POP        R23
;os.c,247 :: 		pop R22
	POP        R22
;os.c,248 :: 		pop R21
	POP        R21
;os.c,249 :: 		pop R20
	POP        R20
;os.c,250 :: 		pop R19
	POP        R19
;os.c,251 :: 		pop R18
	POP        R18
;os.c,252 :: 		pop R17
	POP        R17
;os.c,253 :: 		pop R15
	POP        R15
;os.c,254 :: 		pop R14
	POP        R14
;os.c,255 :: 		pop R13
	POP        R13
;os.c,256 :: 		pop R12
	POP        R12
;os.c,257 :: 		pop R11
	POP        R11
;os.c,258 :: 		pop R10
	POP        R10
;os.c,259 :: 		pop R9
	POP        R9
;os.c,260 :: 		pop R8
	POP        R8
;os.c,261 :: 		pop R7
	POP        R7
;os.c,262 :: 		pop R6
	POP        R6
;os.c,263 :: 		pop R5
	POP        R5
;os.c,264 :: 		pop R4
	POP        R4
;os.c,265 :: 		pop R3
	POP        R3
;os.c,266 :: 		pop R2
	POP        R2
;os.c,267 :: 		pop R1
	POP        R1
;os.c,268 :: 		pop R0
	POP        R0
;os.c,269 :: 		pop r16
	POP        R16
;os.c,270 :: 		out SREG,r16
	OUT        SREG+0, R16
;os.c,271 :: 		pop r16
	POP        R16
;os.c,272 :: 		reti
	RETI
;os.c,274 :: 		}
L_kernel19:
L_kernel18:
;os.c,275 :: 		}
L_kernel16:
;os.c,277 :: 		}
L_kernel2:
;os.c,279 :: 		if(tick==0)
	LDS        R16, _tick+0
	CPI        R16, 0
	BREQ       L__kernel37
	JMP        L_kernel20
L__kernel37:
;os.c,281 :: 		asm { sleep };
	SLEEP
;os.c,282 :: 		}
L_kernel20:
;os.c,284 :: 		}
	JMP        L_kernel0
;os.c,285 :: 		}
L_end_kernel:
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _kernel

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;os.c,287 :: 		void main()
;os.c,289 :: 		task_setup();
	CALL       _task_setup+0
;os.c,290 :: 		os_startup();
	CALL       _os_startup+0
;os.c,291 :: 		kernel();
	CALL       _kernel+0
;os.c,293 :: 		while(1);
L_main21:
	JMP        L_main21
;os.c,294 :: 		}
L_end_main:
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
